/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_ESTADOCONSERVA                                           */
/* Tabela : ESTADOCONSERVA                                                    */
/*                                                                            */
/* Criao:                                                                   */
/* 15/01/2009 - Frederico Gonalves Moreira da Costa                          */
/*                                                                            */
/******************************************************************************/

CREATE OR REPLACE
TRIGGER DTULTATU_ESTADOCONSERVA
BEFORE INSERT OR UPDATE OR DELETE
ON ESTADOCONSERVA FOR EACH ROW
BEGIN
   IF INSERTING THEN
      :NEW.DTULTATU := SYSDATE;
   END IF;
   IF UPDATING THEN
      IF(NVL(:OLD.CDEMPRESA    ,0) <> NVL(:NEW.CDEMPRESA    ,0)) OR
        (NVL(:OLD.CDESTCONSERVA,0) <> NVL(:NEW.CDESTCONSERVA,0)) OR
        (NVL(:OLD.NMESTCONSERVA,0) <> NVL(:NEW.NMESTCONSERVA,0)) OR
        (NVL(:OLD.NMABREVESTCON,0) <> NVL(:NEW.NMABREVESTCON,0)) THEN
         :NEW.DTULTATU := SYSDATE;
      END IF;
   END IF;
   IF DELETING THEN
      INSERT INTO DELETECACHE (NMTABLECACHE,CDFILICACHE,DSKEYCACHE,DTULTATUCACH)
      VALUES ('ESTADOCONSERVA','','CDEMPRESA='||:OLD.CDEMPRESA||';CDESTCONSERVA='||:OLD.CDESTCONSERVA||';',SYSDATE);
   END IF;
END;
/
ALTER TABLE ESTADOCONSERVA MODIFY DTULTATU DEFAULT SYSDATE
/
UPDATE ESTADOCONSERVA SET DTULTATU = SYSDATE WHERE DTULTATU IS NULL
/
-- VERSAO --
BEGIN ATUVEROBJ('DTULTATU_ESTADOCONSERVA','5.05.119'); END;
/

