/*******************************************************************************/
/****                       PEDIDOS / EXPEDIO                             ****/
/*******************************************************************************/

/* Tabela PEDIDO: Cadastro de Pedidos */
/* Descrio: A trigger insere registros na tabela LOGOPERA a partir de alteraes na tabela PEDIDO */
/* Objetivo: Gerar um log que vai registrar as alteraes na tabela Pedidos de Produto(Cadastro de Pedidos),
             utilizando a tabela Geral de Logs de Operaes */

IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE
            o.name = 'LOG_PED_PEDIDO' and
            type = 'TR'         and
            u.uid = o.uid       and
            u.name = USER)
  DROP TRIGGER LOG_PED_PEDIDO
  GO

CREATE TRIGGER LOG_PED_PEDIDO
ON PEDIDO
FOR INSERT, UPDATE, DELETE
AS
   DECLARE @V_USUARIO       VARCHAR(40);
   DECLARE @V_TIPO          VARCHAR(1);
   DECLARE @V_ITPESQ        VARCHAR(40);
   DECLARE @V_DESC          VARCHAR(300);
   DECLARE @V_CDFILLOGOPER  VARCHAR(4);
   DECLARE @V_STSITPED      VARCHAR(2);
   DECLARE @V_DTOPER        DATETIME;

/*VARIVEIS DO CURSOR C_CURSOR*/
   DECLARE @V_ID_COMANDO VARCHAR(1);

   DECLARE @V_CDFILIAL_OLD        VARCHAR(4);
   DECLARE @V_NRPEDIDO_OLD        VARCHAR(10);
   DECLARE @V_DTPEDIDO_OLD        DATETIME;
   DECLARE @V_CDCLIENTE_OLD       VARCHAR(21);
   DECLARE @V_CDVENDEDOR_OLD      VARCHAR(4);
   DECLARE @V_CDMODPGTO_OLD       VARCHAR(5);
   DECLARE @V_CDPRECOBASE_OLD     VARCHAR(2);
   DECLARE @V_IDSITPEDIDO_OLD     VARCHAR(1);
   DECLARE @V_CDFILIALPED_OLD     VARCHAR(4);
   DECLARE @V_CDTIPOOPER_OLD      VARCHAR(2);
   DECLARE @V_IDTIPOPEDIDO_OLD    VARCHAR(1);
   DECLARE @V_DTENTPED_OLD        DATETIME;
   DECLARE @V_DTVALIPED_OLD       DATETIME;
   DECLARE @V_VRPBRUVOLPED_OLD    double precision;
   DECLARE @V_VRPLIQVOLPED_OLD    double precision;
   DECLARE @V_CDROTATRANSPED_OLD  VARCHAR(6);

   DECLARE @V_CDFILIAL_NEW        VARCHAR(4);
   DECLARE @V_NRPEDIDO_NEW        VARCHAR(10);
   DECLARE @V_DTPEDIDO_NEW        DATETIME;
   DECLARE @V_CDCLIENTE_NEW       VARCHAR(21);
   DECLARE @V_CDVENDEDOR_NEW      VARCHAR(4);
   DECLARE @V_CDMODPGTO_NEW       VARCHAR(5);
   DECLARE @V_CDPRECOBASE_NEW     VARCHAR(2);
   DECLARE @V_IDSITPEDIDO_NEW     VARCHAR(1);
   DECLARE @V_CDFILIALPED_NEW     VARCHAR(4);
   DECLARE @V_CDTIPOOPER_NEW      VARCHAR(2);
   DECLARE @V_IDTIPOPEDIDO_NEW    VARCHAR(1);
   DECLARE @V_DTENTPED_NEW        DATETIME;
   DECLARE @V_DTVALIPED_NEW       DATETIME;
   DECLARE @V_VRPBRUVOLPED_NEW    double precision;
   DECLARE @V_VRPLIQVOLPED_NEW    double precision;
   DECLARE @V_CDROTATRANSPED_NEW  VARCHAR(6);
BEGIN

   SET @V_STSITPED = '';
   SET @V_DESC     = '';
   SET @V_TIPO     = '0';
   SET @V_CDFILLOGOPER = '';

   EXEC NMUSUARIO @V_USUARIO;
   SET @V_USUARIO = ISNULL(@V_USUARIO, '');

   DECLARE C_CURSOR CURSOR FOR
      SELECT
         'D' IDCOMANDO,

         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,

         CDFILIAL,
         NRPEDIDO,
         DTPEDIDO,
         CDCLIENTE,
         CDVENDEDOR,
         CDMODPGTO,
         CDPRECOBASE,
         IDSITPEDIDO,
         CDFILIALPED,
         CDTIPOOPER,
         IDTIPOPEDIDO,
         DTENTPED,
         DTVALIPED,
         VRPBRUVOLPED,
         VRPLIQVOLPED,
         CDROTATRANSPED
      FROM
         DELETED
      WHERE
         0 = (SELECT COUNT(*) FROM INSERTED)

      UNION ALL

      SELECT
         'U' IDCOMANDO,

         INSERTED.CDFILIAL,
         INSERTED.NRPEDIDO,
         INSERTED.DTPEDIDO,
         INSERTED.CDCLIENTE,
         INSERTED.CDVENDEDOR,
         INSERTED.CDMODPGTO,
         INSERTED.CDPRECOBASE,
         INSERTED.IDSITPEDIDO,
         INSERTED.CDFILIALPED,
         INSERTED.CDTIPOOPER,
         INSERTED.IDTIPOPEDIDO,
         INSERTED.DTENTPED,
         INSERTED.DTVALIPED,
         INSERTED.VRPBRUVOLPED,
         INSERTED.VRPLIQVOLPED,
         INSERTED.CDROTATRANSPED,

         DELETED.CDFILIAL,
         DELETED.NRPEDIDO,
         DELETED.DTPEDIDO,
         DELETED.CDCLIENTE,
         DELETED.CDVENDEDOR,
         DELETED.CDMODPGTO,
         DELETED.CDPRECOBASE,
         DELETED.IDSITPEDIDO,
         DELETED.CDFILIALPED,
         DELETED.CDTIPOOPER,
         DELETED.IDTIPOPEDIDO,
         DELETED.DTENTPED,
         DELETED.DTVALIPED,
         DELETED.VRPBRUVOLPED,
         DELETED.VRPLIQVOLPED,
         DELETED.CDROTATRANSPED
      FROM
         INSERTED,
         DELETED
      WHERE
         INSERTED.CDCLIENTE  = DELETED.CDCLIENTE AND
         INSERTED.NRPEDIDO   = DELETED.NRPEDIDO

      UNION ALL

      SELECT
         'I' IDCOMANDO,

         INSERTED.CDFILIAL,
         INSERTED.NRPEDIDO,
         INSERTED.DTPEDIDO,
         INSERTED.CDCLIENTE,
         INSERTED.CDVENDEDOR,
         INSERTED.CDMODPGTO,
         INSERTED.CDPRECOBASE,
         INSERTED.IDSITPEDIDO,
         INSERTED.CDFILIALPED,
         INSERTED.CDTIPOOPER,
         INSERTED.IDTIPOPEDIDO,
         INSERTED.DTENTPED,
         INSERTED.DTVALIPED,
         INSERTED.VRPBRUVOLPED,
         INSERTED.VRPLIQVOLPED,
         INSERTED.CDROTATRANSPED,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL
      FROM
         INSERTED
      WHERE
         0 = (SELECT COUNT(*) FROM DELETED)

   OPEN C_CURSOR;
   FETCH NEXT FROM C_CURSOR INTO @V_ID_COMANDO,

                                 @V_CDFILIAL_OLD,
                                 @V_NRPEDIDO_OLD,
                                 @V_DTPEDIDO_OLD,
                                 @V_CDCLIENTE_OLD,
                                 @V_CDVENDEDOR_OLD,
                                 @V_CDMODPGTO_OLD,
                                 @V_CDPRECOBASE_OLD,
                                 @V_IDSITPEDIDO_OLD,
                                 @V_CDFILIALPED_OLD,
                                 @V_CDTIPOOPER_OLD,
                                 @V_IDTIPOPEDIDO_OLD,
                                 @V_DTENTPED_OLD,
                                 @V_DTVALIPED_OLD,
                                 @V_VRPBRUVOLPED_OLD,
                                 @V_VRPLIQVOLPED_OLD,
                                 @V_CDROTATRANSPED_OLD,

                                 @V_CDFILIAL_NEW,
                                 @V_NRPEDIDO_NEW,
                                 @V_DTPEDIDO_NEW,
                                 @V_CDCLIENTE_NEW,
                                 @V_CDVENDEDOR_NEW,
                                 @V_CDMODPGTO_NEW,
                                 @V_CDPRECOBASE_NEW,
                                 @V_IDSITPEDIDO_NEW,
                                 @V_CDFILIALPED_NEW,
                                 @V_CDTIPOOPER_NEW,
                                 @V_IDTIPOPEDIDO_NEW,
                                 @V_DTENTPED_NEW,
                                 @V_DTVALIPED_NEW,
                                 @V_VRPBRUVOLPED_NEW,
                                 @V_VRPLIQVOLPED_NEW,
                                 @V_CDROTATRANSPED_NEW;


   WHILE (@@FETCH_STATUS = 0) BEGIN
      IF NOT @V_USUARIO IS NULL BEGIN
         IF @V_ID_COMANDO = 'D'  BEGIN
            SET @V_TIPO = '3';

            SET @V_DESC   = 'Filial '    + @V_CDFILIAL_OLD          + ' ' +
                            'Pedido '    + @V_NRPEDIDO_OLD          + ' ' +
                            'Dt. Pedido '+ CONVERT(CHAR, @V_DTPEDIDO_OLD, 103) + ' ' +
                            'Cliente '   + @V_CDCLIENTE_OLD         + ' ' +
                            'Vendedor '  + @V_CDVENDEDOR_OLD        + ' ' +
                            'Mod. Pgto ' + @V_CDMODPGTO_OLD         + ' ' +
                            'Preo Base '+ @V_CDPRECOBASE_OLD;

            IF @V_IDSITPEDIDO_OLD = '1' BEGIN SET @V_STSITPED = 'PE'; END;
            IF @V_IDSITPEDIDO_OLD = '2' BEGIN SET @V_STSITPED = 'AN'; END;
            IF @V_IDSITPEDIDO_OLD = '3' BEGIN SET @V_STSITPED = 'LQ'; END;
            IF @V_IDSITPEDIDO_OLD = '4' BEGIN SET @V_STSITPED = 'CN'; END;
            IF @V_IDSITPEDIDO_OLD = '5' BEGIN SET @V_STSITPED = 'LQ'; END;
            IF @V_IDSITPEDIDO_OLD = '6' BEGIN SET @V_STSITPED = 'PA'; END;

            IF (@V_STSITPED <> '') BEGIN
               SET @V_DESC = @V_DESC + ' Situao ' + @V_STSITPED;
            END;

            SET @V_ITPESQ  = @V_CDFILIAL_OLD+@V_NRPEDIDO_OLD;
            SET @V_CDFILLOGOPER = @V_CDFILIAL_OLD;
         END
         ELSE BEGIN

            IF @V_ID_COMANDO = 'U' BEGIN
               SET @V_DESC = 'Filial '    + @V_CDFILIAL_OLD          + ' ' +
                             'Pedido '    + @V_NRPEDIDO_OLD;

               IF (@V_DTPEDIDO_OLD     <> @V_DTPEDIDO_NEW)      OR
                  (@V_CDCLIENTE_OLD    <> @V_CDCLIENTE_NEW)     OR
                  (@V_CDVENDEDOR_OLD   <> @V_CDVENDEDOR_NEW)    OR
                  (@V_CDMODPGTO_OLD    <> @V_CDMODPGTO_NEW)     OR
                  (@V_CDPRECOBASE_OLD  <> @V_CDPRECOBASE_NEW)   OR
                  (@V_IDSITPEDIDO_OLD  <> @V_IDSITPEDIDO_NEW)   OR
                  (@V_CDFILIALPED_OLD  <> @V_CDFILIALPED_NEW)   OR (@V_CDFILIALPED_NEW IS NOT NULL)  OR
                  (@V_CDTIPOOPER_OLD   <> @V_CDTIPOOPER_NEW)    OR (@V_CDTIPOOPER_NEW IS NOT NULL)   OR
                  (@V_IDTIPOPEDIDO_OLD <> @V_IDTIPOPEDIDO_NEW)  OR
                  (@V_DTENTPED_OLD     <> @V_DTENTPED_NEW)      OR
                  (@V_DTVALIPED_OLD    <> @V_DTVALIPED_NEW)     OR (@V_DTVALIPED_NEW IS NOT NULL)    OR
                  (@V_VRPBRUVOLPED_OLD <> @V_VRPBRUVOLPED_NEW)  OR
                  (@V_CDROTATRANSPED_OLD<> @V_CDROTATRANSPED_NEW)OR
                  (@V_VRPLIQVOLPED_OLD <> @V_VRPLIQVOLPED_NEW)  BEGIN
                  SET @V_DESC = @V_DESC + ' Alterado:';
                  SET @V_TIPO = '2';
               END;

               IF @V_CDROTATRANSPED_OLD  <> @V_CDROTATRANSPED_NEW BEGIN
                  SET @V_DESC = @V_DESC + ' Rota de Entrega ' + @V_CDROTATRANSPED_OLD;
               END;

               IF @V_DTPEDIDO_OLD <> @V_DTPEDIDO_NEW BEGIN
                  SET @V_DESC = @V_DESC + ' Dt. Pedido ' + CONVERT(CHAR, @V_DTPEDIDO_OLD);
               END;
               IF @V_CDCLIENTE_OLD <> @V_CDCLIENTE_NEW BEGIN
                  SET @V_DESC = @V_DESC + ' Cliente ' + @V_CDCLIENTE_OLD;
               END;
               IF @V_CDVENDEDOR_OLD <> @V_CDVENDEDOR_NEW BEGIN
                  SET @V_DESC = @V_DESC + ' Vendedor ' + @V_CDVENDEDOR_OLD;
               END;
               IF @V_CDMODPGTO_OLD <> @V_CDMODPGTO_NEW BEGIN
                  SET @V_DESC = @V_DESC + ' Mod. Pgto. ' + @V_CDMODPGTO_OLD;
               END;
               IF @V_CDPRECOBASE_OLD <> @V_CDPRECOBASE_NEW BEGIN
                  SET @V_DESC = @V_DESC + ' Preo Base ' + @V_CDPRECOBASE_OLD;
               END;
               IF @V_IDSITPEDIDO_OLD <> @V_IDSITPEDIDO_NEW BEGIN
                  IF @V_IDSITPEDIDO_OLD = '1' BEGIN SET @V_STSITPED = 'PE'; END;
                  IF @V_IDSITPEDIDO_OLD = '2' BEGIN SET @V_STSITPED = 'AN'; END;
                  IF @V_IDSITPEDIDO_OLD = '3' BEGIN SET @V_STSITPED = 'LQ'; END;
                  IF @V_IDSITPEDIDO_OLD = '4' BEGIN SET @V_STSITPED = 'CN'; END;
                  IF @V_IDSITPEDIDO_OLD = '5' BEGIN SET @V_STSITPED = 'LQ'; END;
                  IF @V_IDSITPEDIDO_OLD = '6' BEGIN SET @V_STSITPED = 'PA'; END;

                  SET @V_DESC = @V_DESC + ' Situao ' + @V_STSITPED;
               END;
               IF (@V_CDFILIALPED_OLD IS NULL) AND
                  (@V_CDFILIALPED_NEW IS NOT NULL) BEGIN
                  SET @V_DESC = @V_DESC + ' Filial Dest. NULL';
               END
               ELSE BEGIN
                  IF (@V_CDFILIALPED_OLD <> @V_CDFILIALPED_NEW) BEGIN
                     SET @V_DESC = @V_DESC + ' Filial Dest. ' + @V_CDFILIALPED_OLD;
                  END;
               END;
               IF (@V_CDTIPOOPER_OLD IS NULL) AND
                  (@V_CDTIPOOPER_NEW IS NOT NULL) BEGIN
                  SET @V_DESC = @V_DESC + ' Tipo Operao NULL';
               END
               ELSE BEGIN
                  IF (@V_CDTIPOOPER_OLD <> @V_CDTIPOOPER_NEW) BEGIN
                     SET @V_DESC = @V_DESC + ' Tipo Operao ' + @V_CDTIPOOPER_OLD;
                  END;
               END;
               IF @V_IDTIPOPEDIDO_OLD <> @V_IDTIPOPEDIDO_NEW BEGIN
                  SET @V_DESC = @V_DESC + ' Tipo ' + @V_IDTIPOPEDIDO_OLD;
               END;
               IF @V_DTENTPED_OLD <> @V_DTENTPED_NEW BEGIN
                  SET @V_DESC = @V_DESC + ' Dt. Entrega ' + CONVERT(CHAR, @V_DTENTPED_OLD);
               END;
               IF (@V_DTVALIPED_OLD IS NULL) AND
                  (@V_DTVALIPED_NEW IS NOT NULL) BEGIN
                  SET @V_DESC = @V_DESC + ' Dt. Validade NULL' ;
               END
               ELSE BEGIN
                  IF (@V_DTVALIPED_OLD <> @V_DTVALIPED_NEW) BEGIN
                     SET @V_DESC = @V_DESC + ' Dt. Validade ' + @V_DTVALIPED_OLD;
                  END;
               END;
               IF (@V_VRPBRUVOLPED_OLD IS NULL) AND
                  (@V_VRPBRUVOLPED_NEW IS NOT NULL) BEGIN
                  SET @V_DESC = @V_DESC + ' Peso Bruto NULL' ;
               END
               ELSE BEGIN
                  IF (@V_VRPBRUVOLPED_OLD <> @V_VRPBRUVOLPED_NEW) BEGIN
                     SET @V_DESC = @V_DESC + ' Peso Bruto ' + CONVERT(CHAR,(ROUND(@V_VRPBRUVOLPED_OLD, 5)));
                  END;
               END;
               IF (@V_VRPLIQVOLPED_OLD IS NULL) AND
                  (@V_VRPLIQVOLPED_NEW IS NOT NULL) BEGIN
                  SET @V_DESC = @V_DESC + ' Peso Lquido NULL' ;
               END
               ELSE BEGIN
                  IF (@V_VRPLIQVOLPED_OLD <> @V_VRPLIQVOLPED_NEW) BEGIN
                     SET @V_DESC = @V_DESC + ' Peso Lquido ' + CONVERT(CHAR,(ROUND(@V_VRPLIQVOLPED_OLD, 5)));
                  END;
               END;

               SET @V_CDFILLOGOPER = @V_CDFILIAL_OLD;
               SET @V_ITPESQ = @V_CDFILIAL_OLD+@V_NRPEDIDO_OLD;
            END
            ELSE BEGIN
               SET @V_TIPO   = '1';
               SET @V_DESC   = 'Filial '    + @V_CDFILIAL_OLD          + ' ' +
                               'Pedido '    + @V_NRPEDIDO_OLD          + ' ' +
--                               'Dt. Pedido '+ CONVERT(CHAR, @V_DTPEDIDO_OLD, 103) + ' ' +
                               'Cliente '   + @V_CDCLIENTE_OLD         + ' ' +
                               'Vendedor '  + @V_CDVENDEDOR_OLD        + ' ' +
                               'Mod. Pgto ' + @V_CDMODPGTO_OLD         + ' ' +
                               'Preo Base '+ @V_CDPRECOBASE_OLD;
               SET @V_ITPESQ = @V_CDFILIAL_OLD+ @V_NRPEDIDO_OLD;
               SET @V_CDFILLOGOPER = @V_CDFILIAL_OLD;
            END;
         END;

         IF @V_TIPO <> '0' BEGIN
            IF NOT @V_DESC IS NULL BEGIN
               SET @V_DTOPER = GETDATE();

               SET @V_DESC = SUBSTRING(ISNULL(@V_DESC, ' '), 1, 300);

               INSERT INTO LOGOPERA(NMTABELA, DTOPERACAO, NMRESPOPER,
                                IDTIPOOPER,   DSOPERACAO,  CDPESQITEM)
                     VALUES   ('PEDIDO', GETDATE() , @V_USUARIO,
                               @V_TIPO,   @V_DESC, ISNULL(@V_ITPESQ, ' '));


            END;
         END;
      END;
      FETCH NEXT FROM C_CURSOR INTO @V_ID_COMANDO,

                                   @V_CDFILIAL_OLD,
                                   @V_NRPEDIDO_OLD,
                                   @V_DTPEDIDO_OLD,
                                   @V_CDCLIENTE_OLD,
                                   @V_CDVENDEDOR_OLD,
                                   @V_CDMODPGTO_OLD,
                                   @V_CDPRECOBASE_OLD,
                                   @V_IDSITPEDIDO_OLD,
                                   @V_CDFILIALPED_OLD,
                                   @V_CDTIPOOPER_OLD,
                                   @V_IDTIPOPEDIDO_OLD,
                                   @V_DTENTPED_OLD,
                                   @V_DTVALIPED_OLD,
                                   @V_VRPBRUVOLPED_OLD,
                                   @V_VRPLIQVOLPED_OLD,
                                   @V_CDROTATRANSPED_OLD,

                                   @V_CDFILIAL_NEW,
                                   @V_NRPEDIDO_NEW,
                                   @V_DTPEDIDO_NEW,
                                   @V_CDCLIENTE_NEW,
                                   @V_CDVENDEDOR_NEW,
                                   @V_CDMODPGTO_NEW,
                                   @V_CDPRECOBASE_NEW,
                                   @V_IDSITPEDIDO_NEW,
                                   @V_CDFILIALPED_NEW,
                                   @V_CDTIPOOPER_NEW,
                                   @V_IDTIPOPEDIDO_NEW,
                                   @V_DTENTPED_NEW,
                                   @V_DTVALIPED_NEW,
                                   @V_VRPBRUVOLPED_NEW,
                                   @V_VRPLIQVOLPED_NEW,
                                   @V_CDROTATRANSPED_NEW;
   END;
   CLOSE      C_CURSOR;
   DEALLOCATE C_CURSOR;
END;
GO

-- VERSAO --
EXEC ATUVEROBJ 'LOG_PED_PEDIDO','5.07.000';
GO


